diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/lr-wpan/bindings/modulegen__gcc_LP64.py ns-3.33/src/lr-wpan/bindings/modulegen__gcc_LP64.py
--- ns-3.32/src/lr-wpan/bindings/modulegen__gcc_LP64.py	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/lr-wpan/bindings/modulegen__gcc_LP64.py	2021-01-09 10:19:22.000000000 -0800
@@ -7580,7 +7597,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::McpsDataIndicationParams', 'arg0'), param('ns3::Ptr< ns3::Packet >', 'arg1')], 
-                   is_virtual=True, custom_name='__call__', is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3MlmeBeaconNotifyIndicationParams_Ns3Ptr__lt__ns3Packet__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -7602,7 +7619,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::MlmeBeaconNotifyIndicationParams', 'arg0'), param('ns3::Ptr< ns3::Packet >', 'arg1')], 
-                   is_virtual=True, custom_name='__call__', is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3MlmePollConfirmParams_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -7624,7 +7641,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::MlmePollConfirmParams', 'arg0')], 
-                   is_virtual=True, custom_name='__call__', is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3MlmeStartConfirmParams_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -7646,7 +7663,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::MlmeStartConfirmParams', 'arg0')], 
-                   is_virtual=True, custom_name='__call__', is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3MlmeSyncLossIndicationParams_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -7668,7 +7685,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::MlmeSyncLossIndicationParams', 'arg0')], 
-                   is_virtual=True, custom_name='__call__', is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3Packet__gt___Double_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -7690,7 +7707,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Packet const >', 'arg0'), param('double', 'arg1')], 
-                   is_virtual=True, custom_name='__call__', is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3Packet__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -7712,7 +7729,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Packet const >', 'arg0')], 
-                   is_virtual=True, custom_name='__call__', is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_char_Unsigned_char_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -7734,7 +7751,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Packet const >', 'arg0'), param('unsigned char', 'arg1'), param('unsigned char', 'arg2')], 
-                   is_virtual=True, custom_name='__call__', is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_short_Const_ns3Address___amp___Const_ns3Address___amp___Ns3NetDevicePacketType_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -7756,7 +7773,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::NetDevice >', 'arg0'), param('ns3::Ptr< ns3::Packet const >', 'arg1'), param('short unsigned int', 'arg2'), param('ns3::Address const &', 'arg3'), param('ns3::Address const &', 'arg4'), param('ns3::NetDevice::PacketType', 'arg5')], 
-                   is_virtual=True, custom_name='__call__', is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -7778,7 +7795,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::NetDevice >', 'arg0')], 
-                   is_virtual=True, custom_name='__call__', is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3SuperframeStatus_Ns3SuperframeStatus_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -7800,7 +7817,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::SuperframeStatus', 'arg0'), param('ns3::SuperframeStatus', 'arg1')], 
-                   is_virtual=True, custom_name='__call__', is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Time_Ns3LrWpanPhyEnumeration_Ns3LrWpanPhyEnumeration_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -7822,7 +7839,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Time', 'arg0'), param('ns3::LrWpanPhyEnumeration', 'arg1'), param('ns3::LrWpanPhyEnumeration', 'arg2')], 
-                   is_virtual=True, custom_name='__call__', is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -7844,7 +7861,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [], 
-                   is_virtual=True, custom_name='__call__', is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3LrWpanNetDevice_methods(root_module, cls):
@@ -8020,12 +8037,12 @@
     cls.add_method('DoDispose', 
                    'void', 
                    [], 
-                   visibility='private', is_virtual=True)
+                   is_virtual=True, visibility='private')
     ## lr-wpan-net-device.h (module 'lr-wpan'): void ns3::LrWpanNetDevice::DoInitialize() [member function]
     cls.add_method('DoInitialize', 
                    'void', 
                    [], 
-                   visibility='private', is_virtual=True)
+                   is_virtual=True, visibility='private')
     return
 
 def register_Ns3HashImplementation_methods(root_module, cls):
@@ -8037,7 +8054,7 @@
     cls.add_method('GetHash32', 
                    'uint32_t', 
                    [param('char const *', 'buffer'), param('std::size_t const', 'size')], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## hash-function.h (module 'core'): uint64_t ns3::Hash::Implementation::GetHash64(char const * buffer, std::size_t const size) [member function]
     cls.add_method('GetHash64', 
                    'uint64_t', 
@@ -8047,7 +8064,7 @@
     cls.add_method('clear', 
                    'void', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3HashFunctionFnv1a_methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/lr-wpan/model/lr-wpan-mac.cc ns-3.33/src/lr-wpan/model/lr-wpan-mac.cc
--- ns-3.32/src/lr-wpan/model/lr-wpan-mac.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/lr-wpan/model/lr-wpan-mac.cc	2021-01-09 10:19:22.000000000 -0800
@@ -386,8 +386,24 @@
   if (b0 == TX_OPTION_ACK)
     {
       // Set AckReq bit only if the destination is not the broadcast address.
-      if (!(macHdr.GetDstAddrMode () == SHORT_ADDR && macHdr.GetShortDstAddr () == "ff:ff"))
+      if (macHdr.GetDstAddrMode () == SHORT_ADDR)
         {
+          // short address and ACK requested.
+          Mac16Address shortAddr = macHdr.GetShortDstAddr ();
+          if (shortAddr.IsBroadcast() || shortAddr.IsMulticast())
+            {
+              NS_LOG_LOGIC ("LrWpanMac::McpsDataRequest: requested an ACK on broadcast or multicast destination (" << shortAddr << ") - forcefully removing it.");
+              macHdr.SetNoAckReq ();
+              params.m_txOptions &= ~uint8_t (TX_OPTION_ACK);
+            }
+          else
+            {
+              macHdr.SetAckReq ();
+            }
+        }
+      else
+        {
+          // other address (not short) and ACK requested
           macHdr.SetAckReq ();
         }
     }
@@ -1113,27 +1129,23 @@
                   // unicast, for me
                   acceptFrame = true;
                 }
-              else if (receivedMacHdr.GetShortDstAddr () == Mac16Address ("ff:ff"))
+              else if (receivedMacHdr.GetShortDstAddr ().IsBroadcast () || receivedMacHdr.GetShortDstAddr ().IsMulticast ())
                 {
-                  // broadcast
-                  acceptFrame = true;
-                }
-              else
-                {
-                  // multicast
-                  // See RFC 4944, Section 12
-                  // Multicast address 16 bits: 100X XXXX XXXX XXXX
-                  uint8_t buf[2];
-                  receivedMacHdr.GetShortDstAddr ().CopyTo (buf);
-                  if (buf[0] & 0x80)
+                  // broadcast or multicast
+                  if (receivedMacHdr.IsAckReq ())
                     {
-                      acceptFrame = true;
+                      // discard broadcast/multicast with the ACK bit set
+                      acceptFrame = false;
                     }
                   else
                     {
-                      acceptFrame = false;
+                      acceptFrame = true;
                     }
                 }
+              else
+                {
+                  acceptFrame = false;
+                }
             }
 
           if (acceptFrame
@@ -1173,9 +1185,9 @@
               // If the received frame is a frame with the ACK request bit set, we immediately send back an ACK.
               // If we are currently waiting for a pending ACK, we assume the ACK was lost and trigger a retransmission after sending the ACK.
               if ((receivedMacHdr.IsData () || receivedMacHdr.IsCommand ()) && receivedMacHdr.IsAckReq ()
-                  && !(receivedMacHdr.GetDstAddrMode () == SHORT_ADDR && receivedMacHdr.GetShortDstAddr () == "ff:ff"))
+                  && !(receivedMacHdr.GetDstAddrMode () == SHORT_ADDR && (receivedMacHdr.GetShortDstAddr ().IsBroadcast () || receivedMacHdr.GetShortDstAddr ().IsMulticast ())))
                 {
-                  // If this is a data or mac command frame, which is not a broadcast,
+                  // If this is a data or mac command frame, which is not a broadcast or multicast,
                   // with ack req set, generate and send an ack frame.
                   // If there is a CSMA medium access in progress we cancel the medium access
                   // for sending the ACK frame. A new transmission attempt will be started
@@ -1421,7 +1433,7 @@
   Ptr<Packet> pkt = p->Copy ();
   LrWpanMacHeader hdr;
   pkt->RemoveHeader (hdr);
-  if (hdr.GetShortDstAddr () != Mac16Address ("ff:ff"))
+  if (!hdr.GetShortDstAddr ().IsBroadcast () && !hdr.GetShortDstAddr ().IsMulticast())
     {
       m_sentPktTrace (p, m_retransmission + 1, m_numCsmacaRetry);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/lr-wpan/model/lr-wpan-net-device.cc ns-3.33/src/lr-wpan/model/lr-wpan-net-device.cc
--- ns-3.32/src/lr-wpan/model/lr-wpan-net-device.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/lr-wpan/model/lr-wpan-net-device.cc	2021-01-09 10:19:22.000000000 -0800
@@ -65,6 +65,11 @@
                    BooleanValue (true),
                    MakeBooleanAccessor (&LrWpanNetDevice::m_useAcks),
                    MakeBooleanChecker ())
+    .AddAttribute ("PseudoMacAddressMode", "Build the pseudo-MAC Address according to RFC 4944 or RFC 6282 (default: RFC 6282).",
+                   EnumValue (LrWpanNetDevice::RFC6282),
+                   MakeEnumAccessor (&LrWpanNetDevice::m_pseudoMacMode),
+                   MakeEnumChecker (LrWpanNetDevice::RFC6282, "RFC 6282 (don't use PanId)",
+                                    LrWpanNetDevice::RFC4944, "RFC 4944 (use PanId)"))
   ;
   return tid;
 }
@@ -474,7 +479,15 @@
 {
   NS_LOG_FUNCTION (this);
   // TODO: Use the PromiscReceiveCallback if the MAC is in promiscuous mode.
-    m_receiveCallback (this, pkt, 0, BuildPseudoMacAddress (params.m_srcPanId, params.m_srcAddr));
+
+  if (params.m_dstAddrMode == SHORT_ADDR)
+    {
+      m_receiveCallback (this, pkt, 0, BuildPseudoMacAddress (params.m_srcPanId, params.m_srcAddr));
+    }
+  else
+    {
+      m_receiveCallback (this, pkt, 0, params.m_srcExtAddr);
+    }
 }
 
 bool
@@ -491,10 +504,19 @@
 
   uint8_t buf[6];
 
-  buf[0] = panId >> 8;
-  // Make sure the U/L bit is set
-  buf[0] |= 0x02;
-  buf[1] = panId & 0xff;
+  if (m_pseudoMacMode == RFC4944)
+    {
+      buf[0] = panId >> 8;
+      // Make sure the U/L bit is set
+      buf[0] |= 0x02;
+      buf[1] = panId & 0xff;
+    }
+  else
+    {
+      // Make sure the U/L bit is set
+      buf[0] = 0x02;
+      buf[1] = 0x00;
+    }
   buf[2] = 0;
   buf[3] = 0;
   shortAddr.CopyTo (buf+4);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/lr-wpan/model/lr-wpan-net-device.h ns-3.33/src/lr-wpan/model/lr-wpan-net-device.h
--- ns-3.32/src/lr-wpan/model/lr-wpan-net-device.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/lr-wpan/model/lr-wpan-net-device.h	2021-01-09 10:19:22.000000000 -0800
@@ -60,6 +60,17 @@
   virtual ~LrWpanNetDevice (void);
 
   /**
+   * How the pseudo-MAC address is built from
+   * the short address (XXXX) and the PanId (YYYY).
+   *
+   * See \RFC{4944} and \RFC{6282}.
+   */
+  enum PseudoMacAddressMode_e {
+    RFC4944,  //!< YYYY:0000:XXXX (with U/L bit set to local)
+    RFC6282   //!< 0200:0000:XXXX
+  };
+
+  /**
    * Set the MAC to be used by this NetDevice.
    *
    * \param mac the MAC to be used
@@ -260,6 +271,14 @@
    * Upper layer callback used for notification of new data packet arrivals.
    */
   ReceiveCallback m_receiveCallback;
+
+  /**
+   * How the pseudo MAC address is created.
+   *
+   * According to \RFC{4944} the psudo-MAC is YYYY:0000:XXXX (with U/L bit set to local)
+   * According to \RFC{6282} the psudo-MAC is 0200:0000:XXXX
+   */
+  PseudoMacAddressMode_e m_pseudoMacMode;
 };
 
 } // namespace ns3
